library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity tcnt is
    Port ( takt : in std_logic;
           reset : in std_logic;
           load : in std_logic;
           d : in std_logic_vector(4 downto 0);
           q : out std_logic_vector(4 downto 0));
end tcnt;

architecture Behavioral of tcnt is
signal qi : std_logic_vector(4 downto 0);
begin
  
  ct: PROCESS (takt,reset,load,d)
      BEGIN
        IF reset='1' THEN qi <= "00000";
          ELSIF takt'event and takt='1' 
	      THEN IF load='1' THEN qi <= d; 
		                    ELSE qi <= qi - 1; END IF;
	END IF;
      END PROCESS ct;

  q <= qi;
end Behavioral;
